- Main Page
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Mers::Generators::BFIG::BFIGFactory Class Reference

`#include <BFIGFactory.h>`

Inheritance diagram for Mers::Generators::BFIG::BFIGFactory:

[legend]
Collaboration diagram for Mers::Generators::BFIG::BFIGFactory:

[legend]
List of all members.

## Public Member Functions
virtual BFIG * | create (std::vector< BFIGVariable * > const &variableSet, double cutoffCost)=0 throw ()
virtual BFIG * | create (std::vector< BFIGVariable * > const &variableSet)=0 throw ()
virtual BFIG * | create (std::vector< BFIGVariable * > const &variableSet, BFIGObjectiveFunction const *ocspObjectiveFunction, double cutoffCost)=0 throw ()

## Detailed Description

A factory that can be used to create a BFIG object given the appropriate set of initializers. BFIG derivatives should implement a version of this factory

Author:
  Paul H. Elliott

Definition at line 31 of file BFIGFactory.h.

## Member Function Documentation

virtual BFIG* Mers::Generators::BFIG::BFIGFactory::create | ( | std::vector< BFIGVariable * > const & | variableSet,
|  | double | cutoffCost |
| ) |  |  | throw ()`[pure virtual]`

Returns a new BFIG object given the set of variables that should be enumerated over. This version will include a maximum cost at which no further candidates are generated.

Parameters:

  | variableSet | The set of variables that need to be enumerated over.
  | cutoffCost | The cost at which the candidate will no longer be returned.

Returns:
  A BFIG object that will enumerated over the specified variables. The function will throw an exception if it is given invalid arguments, and will thus never return NULL.

Referenced by Mers::Generators::BFIG::BFIGGenerator::BFIGGenerator().

virtual BFIG* Mers::Generators::BFIG::BFIGFactory::create | ( | std::vector< BFIGVariable * > const & | variableSet | ) | throw ()`[pure virtual]`

Returns a new BFIG object given the set of variables that should be enumerated over. All possible candidates will be returned.

Parameters:

  | variableSet | The set of variables that need to be enumerated over.

Returns:
  A BFIG object that will enumerated over the specified variables. The function will throw an exception if it is given invalid arguments, and will thus never return NULL.

virtual BFIG* Mers::Generators::BFIG::BFIGFactory::create | ( | std::vector< BFIGVariable * > const & | variableSet,
|  | BFIGObjectiveFunction const * | ocspObjectiveFunction,
|  | double | cutoffCost |
| ) |  |  | throw ()`[pure virtual]`

Returns a new BFIG object given the set of variables that should be enumerated over and the objective function to use

Parameters:

  | variableSet | The set of variables that need to be enumerated over.
  | ocspObjectiveFunction | the OCSP objective function to be used with BFIG to enumerate the solutions to the OCSP in best-first order.
  | cutoffCost | The cost at which the candidate will no longer be returned.

Returns:
  A BFIG object that will enumerated over the specified variables. The function will throw an exception if it is given invalid arguments, and will thus never return NULL.

The documentation for this class was generated from the following file:

- /Users/fpy/titan-1-5-MBARI/Mers/Generators/BFIG/BFIGFactory.h